﻿using System;
using System.Collections.Generic;

public partial class _Default : System.Web.UI.Page
{

    //creation of SortedDictionary
    static SortedDictionary<string, string> SamartPhoneSortedDictionary;

    /// <summary>
    /// Page load event
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void Page_Load(object sender, EventArgs e)
    {
        lblSortedDictionaryDisplay.Text = "";

        if (!IsPostBack)
        {
            SamartPhoneSortedDictionary = new SortedDictionary<string, string>();
            //add the items in SortedDictionary
            SamartPhoneSortedDictionary.Add("IPhone 2", "One");
            SamartPhoneSortedDictionary.Add("IPhone 3", "Two");
            SamartPhoneSortedDictionary.Add("IPhone 4", "Three");
            SamartPhoneSortedDictionary.Add("Samsung Note", "Four");
            SamartPhoneSortedDictionary.Add("Samsung S2", "Five");
            SamartPhoneSortedDictionary.Add("Samsung S3", "Six");           
        }
        DisplayData();
    }

    /// <summary>
    /// Add items in SortedDictionary
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void btnAdd_Click(object sender, EventArgs e)
    {
        if (txtSortedDictionaryKey.Text.Trim() != "" && txtSortedDictionaryValue.Text.Trim() != "")
        {
            if (!SamartPhoneSortedDictionary.ContainsKey(txtSortedDictionaryKey.Text.Trim()))
            {
                SamartPhoneSortedDictionary.Add(txtSortedDictionaryKey.Text.Trim(), txtSortedDictionaryValue.Text.Trim());

                lblSortedDictionaryDisplay.Text = "SortedDictionary Item Added";
            }
            else
            {
                lblSortedDictionaryDisplay.Text = "SortedDictionary - Key Already Exist";
            }
        }
        else
        {
            lblSortedDictionaryDisplay.Text = "SortedDictionary - Please Enter an Item to Add";
        }
        DisplayData();
    }

    /// <summary>
    /// Delete items from SortedDictionary
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void btnDelete_Click(object sender, EventArgs e)
    {

        if (txtSortedDictionaryKey.Text.Trim() != "")
        {
            if (SamartPhoneSortedDictionary.ContainsKey(txtSortedDictionaryKey.Text.Trim()))
            {
                SamartPhoneSortedDictionary.Remove(txtSortedDictionaryKey.Text.Trim());

                lblSortedDictionaryDisplay.Text = "SortedDictionary Item Deleted";
            }
            else
            {
                lblSortedDictionaryDisplay.Text = "SortedDictionary - Item Not Found.";
            }
        }
        else
        {
            lblSortedDictionaryDisplay.Text = "SortedDictionary - Please Enter an Item to Delete";
        }
        DisplayData();
    }

    /// <summary>
    /// Search items by Key
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void btnSearchbyKey_Click(object sender, EventArgs e)
    {
        if (txtSortedDictionaryKey.Text.Trim() != "")
        {
            if (SamartPhoneSortedDictionary.ContainsKey(txtSortedDictionaryKey.Text.Trim()))
            {
                lblSortedDictionaryDisplay.Text = "SortedDictionary Item Found";
            }
            else
            {
                lblSortedDictionaryDisplay.Text = "SortedDictionary Item Not Found.";
            }
        }
        else
        {
            lblSortedDictionaryDisplay.Text = "Please Enter an Item to Search";
        }
        DisplayData();
    }

    /// <summary>
    /// Search Items by Value
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void btnSearchbyValue_Click(object sender, EventArgs e)
    {


        if (txtSortedDictionaryValue.Text.Trim() != "")
        {
            if (SamartPhoneSortedDictionary.ContainsValue(txtSortedDictionaryValue.Text.Trim()))
            {
                lblSortedDictionaryDisplay.Text = "SortedDictionary Item Found";
            }
            else
            {
                lblSortedDictionaryDisplay.Text = "SortedDictionary Item Not Found.";
            }
        }
        else
        {
            lblSortedDictionaryDisplay.Text = "Please Enter an Item to Search";
        }
        DisplayData();
    }

   /// <summary>
    /// SortedDictionary Data Display
   /// </summary>
    private void DisplayData()
    {
        lblSortedDictionaryState.Text = "";

        foreach (KeyValuePair<string, string> pair in SamartPhoneSortedDictionary)
        {
            lblSortedDictionaryState.Text += "," + pair.Key + ":" + pair.Value;
        }
        lblSortedDictionaryState.Text = lblSortedDictionaryState.Text.TrimStart(',');
    }

    /// <summary>
    /// Other common methods of SortedDictionary
    /// </summary>
    private void OtherFunctionality()
    {
        string strValue = "";
        lblSortedDictionaryDisplay.Text = " Get the Value for a Key: " + SamartPhoneSortedDictionary.TryGetValue(txtSortedDictionaryKey.Text.Trim(), out strValue);

        //Clear all the items of SortedDictionary
        SamartPhoneSortedDictionary.Clear();

        lblSortedDictionaryDisplay.Text = " Count of All the Items of SortedDictionary: " + SamartPhoneSortedDictionary.Count;

        //lblSortedDictionaryDisplay.Text = " Capacity of All the Items of SortedDictionary: " + SamartPhoneSortedDictionary.Capacity;

        //value looping
        foreach (string str in SamartPhoneSortedDictionary.Values)
        {
            lblSortedDictionaryState.Text += "," + str;
        }

        //key looping
        foreach (string str in SamartPhoneSortedDictionary.Keys)
        {
            lblSortedDictionaryState.Text += "," + str;
        }

    }


}
